#include "stdafx.h"
#include "PerfCtrv2Mgr.h"

#pragma warning(push)
#pragma warning(disable: 26477 26494)
#include "PerfCountersv2.h"
#pragma warning(pop)


int _tmain() noexcept
{
  //Initialize the provider
  CPerfProvider PerfProvider;
  ULONG nStatus{PerfProvider.StartEx(&PerfCountersv2PerfProviderGuid)};
  if (nStatus != ERROR_SUCCESS)
  {
    _tprintf(_T("Failed to initialize perf provider, error:%u\n"), nStatus); //NOLINT(clang-diagnostic-format)
    return 1;
  }

  //Initialize the first counter set
  CPerfCounterSet Perf1;
  nStatus = PerfProvider.SetCounterSetInfo(&PerfCountersv2CounterSet1Info.CounterSet, sizeof(PerfCountersv2CounterSet1Info));
  if (nStatus != ERROR_SUCCESS)
  {
    _tprintf(_T("Failed to set counter set info for first counterset, error:%u\n"), nStatus); //NOLINT(clang-diagnostic-format)
    return 1;
  }
  Perf1.Initialize(&PerfProvider);
  nStatus = Perf1.CreateInstance(&PerfCountersv2CounterSet1Guid, L"", 1);
  if (nStatus != ERROR_SUCCESS)
  {
    _tprintf(_T("Failed to create first counter, error:%u\n"), nStatus); //NOLINT(clang-diagnostic-format)
    return 1;
  }
  Perf1.SetL(PERCOUNTERSV2_PERFCOUNTERSET1_VALUE, 42);

  //Initialize the second counter set
  CPerfCounterSet Perf2;
  nStatus = PerfProvider.SetCounterSetInfo(&PerfCountersv2CounterSet2Info.CounterSet, sizeof(PerfCountersv2CounterSet2Info));
  if (nStatus != ERROR_SUCCESS)
  {
    _tprintf(_T("Failed to set counter set info for first counterset, error:%u\n"), nStatus); //NOLINT(clang-diagnostic-format)
    return 1;
  }
  Perf2.Initialize(&PerfProvider);
  nStatus = Perf2.CreateInstance(&PerfCountersv2CounterSet2Guid, L"An Instance name", 1);
  if (nStatus != ERROR_SUCCESS)
  {
    _tprintf(_T("Failed to create first counter, error:%u\n"), nStatus); //NOLINT(clang-diagnostic-format)
    return 1;
  }
  Perf2.SetL(PERCOUNTERSV2_PERFCOUNTERSET2_VALUE, 62);

  //Now change the counter values on a period of seconds to demonstrate the counter values changing
  for (int i{0}; i<30; i++)
  {
    int nValue{rand() % 2};
    if (nValue)
      Perf1.IncrementL(PERCOUNTERSV2_PERFCOUNTERSET1_VALUE, 1);
    else
      Perf1.DecrementL(PERCOUNTERSV2_PERFCOUNTERSET1_VALUE, 1);

    nValue = rand() % 2;
    if (nValue)
      Perf2.IncrementL(PERCOUNTERSV2_PERFCOUNTERSET2_VALUE, 1);
    else
      Perf2.DecrementL(PERCOUNTERSV2_PERFCOUNTERSET2_VALUE, 1);

    //Sleep before we loop around
    Sleep(1000);
  }

  return 0;
}
